//+------------------------------------------------------------------+
//|                                                201028_102504.mqh |
//|                                    2019-2020, dimitri pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| concrete colleague 1                                             |
//+------------------------------------------------------------------+
#include <Mqh\201028_103044.mqh> //colleague
#include <Mqh\201028_102459.mqh> //mediator
//---
class ConcreteColleague1:public Colleague
  {
protected:
   Mediator*         m_mediator;
public:
                     ConcreteColleague1(Mediator& mediator);
   void              Notify(string message);
   void              Send(string message);
  };
//+------------------------------------------------------------------+
//| constructor                                                      |
//+------------------------------------------------------------------+
ConcreteColleague1::ConcreteColleague1(Mediator& meditor):
   m_mediator(&meditor)
  {
  }
//+------------------------------------------------------------------+
//| notify                                                           |
//+------------------------------------------------------------------+
void ConcreteColleague1::Notify(string message)
  {
   printf("colleague 1 notified about %s",message);
  }
//+------------------------------------------------------------------+
//| send                                                             |
//+------------------------------------------------------------------+
void ConcreteColleague1::Send(string message)
  {
   printf("colleague 1 sending %s",message);
   m_mediator.Send(message,this);
  }
//+------------------------------------------------------------------+
